<script lang="ts">
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';
import { SolutionsVideoModal } from '../solutions/index.vue';

export default {
  name: 'VideoSpotlight',
  components: {
    SolutionsVideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      default: null,
    },
  },
  data() {
    return {
      modal: {
        open: false,
        video: false,
      },
    };
  },
  methods: {
    closeModal() {
      this.modal.open = false;
      this.modal.video = false;
    },
    openModal() {
      this.modal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
  },
};
</script>

<template>
  <div class="video-spotlight">
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="8">
          <SlpTypography tag="h2" variant="heading2-bold">
            {{ data.header }}</SlpTypography
          ></SlpColumn
        ></SlpRow
      >
      <SlpRow class="container__row">
        <SlpColumn :cols="5" class="slp-mt-48">
          <div>
            <ul v-if="data.list.length" class="slp-mb-32 video-spotlight__list">
              <li
                v-for="item in data.list"
                :key="item.text"
                class="video-spotlight__list-item slp-mt-24"
              >
                <SlpIcon
                  v-if="item.iconName"
                  :icon="item.iconName"
                  size="sm"
                  class="slp-mr-16 video-spotlight__icon"
                  color="accent-400"
                />
                <SlpTypography
                  v-if="item.text"
                  tag="span"
                  variant="heading5-bold"
                >
                  {{ item.text }}
                </SlpTypography>
              </li>
            </ul>
          </div>
          <div
            class="video-spotlight__blurb"
            v-html="$md.render(data.blurb)"
          ></div>
          <SlpButton
            class="slp-mt-32 video-spotlight__cta"
            variant="primary"
            :href="data.button.externalUrl"
            :data-ga-name="data.button.data_ga_name"
            :data-ga-location="data.button.data_ga_location"
          >
            {{ data.button.text }}
          </SlpButton>
        </SlpColumn>
        <SlpColumn :cols="7" class="slp-mt-64">
          <div class="video-spotlight__video">
            <img :src="data.video.image" />
            <SlpButton
              variant="secondary"
              :data-ga-name="data.video.data_ga_name"
              :data-ga-location="data.video.data_ga_location"
              class="video-spotlight__button"
              @click.native="openModal"
            >
              <SlpIcon
                icon="slp-play-circle"
                size="sm"
                class="slp-mr-16"
                color="accent-400"
              />
              {{ data.video.text }}
            </SlpButton>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
    <SolutionsVideoModal
      v-show="modal.open"
      light-background
      :visible="modal.open"
      @close="closeModal"
    >
      <template #body>
        <lite-vimeo
          ref="video"
          :videoid="getVimeoVideoId(createVideoSource(data.video.url))"
          :videotitle="getVimeoVideoId(data.video.url)"
          autoplay
        ></lite-vimeo>
      </template>
    </SolutionsVideoModal>
  </div>
</template>

<style lang="scss" scoped>
.video-spotlight {
  padding: 80px 0;
  @media (min-width: $breakpoint-md) {
    padding: 160px 0;
  }

  &__list-item {
    display: flex;
  }
  &__icon {
    height: 24px;
    width: 24px;
  }
  &__blurb {
    font-size: 18px;
    font-weight: 400;
    line-height: 28px;
    letter-spacing: 0em;
    text-align: left;
  }
  &__video {
    position: relative;
    img {
      width: 100%;
    }
  }
  &__button {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate3d(-50%, -50%, 0);
    width: 100%;
    max-width: 170px;
    border-radius: 48px;
  }
  &__cta {
    width: 100%;
    justify-content: center;
    @media (min-width: $breakpoint-md) {
      width: auto;
    }
  }
  :deep .slp-col-md-5 {
    width: 100%;
  }
}
</style>
